# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject1
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/8/5 10:51
# Description:
# #号开头的代码表示注释信息
# ---------------------------------------------------------------------------
import logging

import allure
import pytest


from homewoke.接口pytest框架.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM系统")
    @pytest.mark.parametrize("module,interface, title, level, method, url, mime, case_data, expect_data, sql_type, "
                             "sql_sentence, update_key, i", ReadExcel().get_data())
    def test_bpm(self, db_fix, my_rep, module,interface, title, level, method, url, mime, case_data, expect_data,
                 sql_type, sql_sentence, update_key, i):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)
        print(module, interface, title, level, method, url, mime, case_data, expect_data,
                 sql_type, sql_sentence, update_key, i)
        read_excel = ReadExcel()
        datas = read_excel.get_data()
        if sql_type == "delete":
            db_fix.delete(sql_sentence)
        elif sql_type == "select":
            select_result = db_fix.select(sql_sentence)
            case_data[update_key] = select_result
        elif sql_type == "select|delete" or sql_type == "delete|select":
            # 添加组织先执行删除的sql语句. 这里的sql语句存放在一个字典中，
            # 字典的格式为：{"delete":"删除sql语句",
            # "select":"查询sql语句"}
            db_fix.delete(sql_sentence["delete"])
            select_result = db_fix.select(sql_sentence["select"])
            case_data[update_key] = select_result

        result = my_rep.request_all(method=method,url=url,mime=mime,case_data=case_data)

        print("Excel中写的数据", module, interface, title, level, method, url, mime, case_data, expect_data, sql_type,
              sql_sentence, update_key, i)
        print("*"*100)
        print("服务器返回的数据", result.json())
        for i in datas:
            try:
                for key in expect_data.keys():
                    assert expect_data[key] == result.json().get(key)
            except:
                print("断言失败")
                logging.error("断言失败, 模块名称为：{}，接口名称为：{}，用例标题：{}，用例为：{}，期望结果为：{}，服务器返回数据为：{}".format(module, interface, title, str(case_data), str(expect_data), result.text))
                read_excel.write_result("断言失败", i[-1])
                raise AssertionError("断言失败")
            else:
                print("断言成功")
                read_excel.write_result("断言成功", i[-1])


if __name__ == '__main__':
    pytest.main()




