# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject1
# FileName:      requests_method.py
# Author:       xxxxxxx
# Datetime:     2023/8/3 19:11
# Description:
# #号开头的代码表示注释信息
# ---------------------------------------------------------------------------
import base64

import requests

from homewoke.接口自动化框架_登录_添加维度.common.read_ini import ReadIni


class RequestsMethod:
    def __init__(self) :
        login_url = ReadIni().get_host("test_bpm")+"/auth"
        login_data = {"username": "admin", "password": "123456"}
        login_data["password"] = base64.b64encode(login_data["password"].encode("utf-8")).decode("utf-8")
        self.bpm_session = requests.sessions.Session()
        resp = self.bpm_session.request(method="post",url=login_url,json=login_data)
        token = resp.json().get("token")
        self.bpm_session.headers["Authorization"] = "Bearer " + token

    def request_all(self, method, url, mime, case_data):
        if mime == "application/x-www-form-urlencoded" or mime == "x-www-form-urlencoded" or mime == "urlencoded":
            return self.bpm_session.request(method=method,url=url, data=case_data)
        elif mime == "application/json" or mime == "json":
            return self.bpm_session.request(method=method, url=url, json=case_data)
        elif mime == "multipart/from-data" or mime == "from-data":
            return self.bpm_session.request(method=method, url=url, files=case_data)
        # 判断媒体类型的值是否query或者为params的媒体类型，如果是，使用params关键字传参
        elif mime == "query" or mime== "params":
            return self.bpm_session.request(method=method, url=url, params=case_data)
        # 判断媒体类型的值是否text/plain或者为text的媒体类型，如果是，使用data关键字传参
        elif mime== "text/plain" or mime == "text":
            return self.bpm_session.request(method=method, url=url, data=case_data)
        # 判断媒体类型的值是否为application/Json|query或者json|query，如果是，表示地址栏和请求体同时传参
        elif mime == "application/json|query" or mime == "json|query" or mime =="json|params":
            return self.bpm_session.request(method=method, url=url, params=case_data["query"], json=case_data["body"])
        elif mime is None:
            return self.bpm_session.request(method=method,url=url)
        else:
            raise NameError("传入的媒体类型错误")


if __name__ == '__main__':
    requests_method= RequestsMethod()
